Page MenuHomePhabricator

Do not use frame pointer by default for MSP430
ClosedPublic

Authored by dmikushin on Jan 18 2019, 11:57 AM.

Details

Summary

3.3.9 Frame Pointer
MSP430 does not use a frame pointer. This effectively limits a single call frame to 0x7fff bytes, which is the minimum SP offset supported by any instruction

We do allow user to manually enable frame pointer. GCC toolchain uses the same behavior.

Diff Detail

Repository
rL LLVM

Event Timeline

dmikushin created this revision.Jan 18 2019, 11:57 AM
dmikushin updated this revision to Diff 182998.Jan 22 2019, 4:41 PM

@grimar Please find the updated patch with a test case.

Thanks for adding a test case! I know not enough about msp430/clang to verify it, unfortunately.
(I just asked for a test because it is always useful to have one for any non-NFC patch).

asl requested changes to this revision.Jan 25 2019, 1:20 AM

Patch fails to apply. Please rebase.

This revision now requires changes to proceed.Jan 25 2019, 1:20 AM
krisb added a subscriber: krisb.Jan 25 2019, 7:25 AM
krisb added inline comments.
test/CodeGen/msp430-fp-elim.c
16 ↗(On Diff #182998)

This test as it is will fail after integrated assembler will be turned on by default (see https://reviews.llvm.org/D56787). Since calla instruction isn't supported yet, the assembler will report an error of 'invalid instruction mnemonic'.
So, please, choose another instruction from ones that are already supported. Or turn -integrated-as off.

dmikushin updated this revision to Diff 184116.Jan 29 2019, 9:51 AM
dmikushin edited the summary of this revision. (Show Details)

Unbreaking clang driver patch. Not using calla asm instruction, as recomended.

asl accepted this revision.Feb 5 2019, 12:14 PM

Ok now

This revision is now accepted and ready to land.Feb 5 2019, 12:14 PM
Herald added a project: Restricted Project. · View Herald TranscriptFeb 5 2019, 12:14 PM
This revision was automatically updated to reflect the committed changes.
Herald added a project: Restricted Project. · View Herald TranscriptFeb 5 2019, 12:16 PM